//+------------------------------------------------------------------+
//|                                                HMA color nrp.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link "mladenfx@gmail.com"

#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color1 Yellow
#property indicator_color2 LimeGreen
#property indicator_color3 LimeGreen
#property indicator_color4 Orange
#property indicator_color5 Orange
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property indicator_width4 2
#property indicator_width5 2

//
//
//
//
//

extern ENUM_TIMEFRAMES    TimeFrame     = PERIOD_CURRENT;
extern int                HMA_Period    = 144;
extern ENUM_APPLIED_PRICE HMA_PriceType = 0;
extern ENUM_MA_METHOD     HMA_Method    = 3;



int HalfPeriod;
int HullPeriod;

//
//
//
//
//

double ind_buffer0[];
double ind_buffer1[];
double ind_buffer2[];
double ind_buffer3[];
double ind_buffer4[];
double buffer[];
double trend[];
string indicatorFileName;
bool   returnBars;
int    timeFrame;


//+------------------------------------------------------------------
//|                                                                 |
//+------------------------------------------------------------------

int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0,ind_buffer0);
   SetIndexBuffer(1,ind_buffer1);
   SetIndexBuffer(2,ind_buffer2);
   SetIndexBuffer(3,ind_buffer3);
   SetIndexBuffer(4,ind_buffer4);
   SetIndexBuffer(5,buffer);
   SetIndexBuffer(6,trend);

   HMA_Period        = MathMax(2,HMA_Period);
   HalfPeriod        = MathFloor(HMA_Period/2);
   HullPeriod        = MathFloor(MathSqrt(HMA_Period));
   indicatorFileName = WindowExpertName();
   returnBars        = TimeFrame==-99;
   TimeFrame         = MathMax(TimeFrame,_Period);
   
   IndicatorShortName("HMA("+HMA_Period+")");
   return(0);
}

int deinit()
{
    
return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int start()
{
   int    i,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
            if (returnBars) { ind_buffer0[0] = limit+1; return(0); }
            if (TimeFrame!=Period())
            {
               limit = (int)MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
               if (trend[limit] ==  1) CleanPoint(limit,ind_buffer1,ind_buffer2);
               if (trend[limit] == -1) CleanPoint(limit,ind_buffer3,ind_buffer4);
               for (i=limit; i>=0; i--)
               {
                  int y = iBarShift(NULL,TimeFrame,Time[i]);              
                     ind_buffer0[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,HMA_Period,HMA_PriceType,HMA_Method,0,y);
                     ind_buffer1[i] = EMPTY_VALUE;
                     ind_buffer2[i] = EMPTY_VALUE;
                     ind_buffer3[i] = EMPTY_VALUE;
                     ind_buffer4[i] = EMPTY_VALUE;
                     trend[i]       = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,HMA_Period,HMA_PriceType,HMA_Method,6,y);
                    
               }
               for (i=limit; i>=0; i--) 
               {
                   if (trend[i] ==  1) PlotPoint(i,ind_buffer1,ind_buffer2,ind_buffer0);
                   if (trend[i] == -1) PlotPoint(i,ind_buffer3,ind_buffer4,ind_buffer0);
               }
   return(0);
   }
   
   //
   //
   //
   //
   //
 
   if (trend[limit] ==  1) CleanPoint(limit,ind_buffer1,ind_buffer2);
   if (trend[limit] == -1) CleanPoint(limit,ind_buffer3,ind_buffer4);
   for(i=limit; i>=0; i--) buffer[i]=iMA(NULL,0,HalfPeriod,0,HMA_Method,HMA_PriceType,i)*2- iMA(NULL,0,HMA_Period,0,HMA_Method,HMA_PriceType,i);
   for(i=limit; i>=0; i--)
   {
      ind_buffer0[i] = iMAOnArray(buffer,0,HullPeriod,0,HMA_Method,i);
      ind_buffer1[i] = EMPTY_VALUE;
      ind_buffer2[i] = EMPTY_VALUE;
      ind_buffer3[i] = EMPTY_VALUE;
      ind_buffer4[i] = EMPTY_VALUE;
      
      //
      //
      //
      //
      //

      trend[i] = trend[i+1];            
         if (ind_buffer0[i] > ind_buffer0[i+1]) trend[i] =  1; 
         if (ind_buffer0[i] < ind_buffer0[i+1]) trend[i] = -1; 
         if (trend[i] ==  1) PlotPoint(i,ind_buffer1,ind_buffer2,ind_buffer0);
         if (trend[i] == -1) PlotPoint(i,ind_buffer3,ind_buffer4,ind_buffer0);
   }
return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
      if (first[i+2] == EMPTY_VALUE) {
          first[i]    = from[i];
          first[i+1]  = from[i+1];
          second[i]   = EMPTY_VALUE;
         }
      else {
          second[i]   = from[i];
          second[i+1] = from[i+1];
          first[i]    = EMPTY_VALUE;
         }
      }
   else
      {
         first[i]   = from[i];
         second[i]  = EMPTY_VALUE;
      }
}


//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}
